#ifndef _MNODE
#define _MNODE

#include "pre.h"
#include <malloc.h>
#include <stdio.h>


class MNode {

     public:
	MosList *moshead;
	NodeList *nodehead;
	InoutList *inputhead;
	InoutList *outputhead;


	MNode(MosList *moshead_, InoutList *inputhead);
	~MNode();

	DeviceList *insert_device(DeviceList *head, MosList *mos, PinType pintype);
	NodeList *insert_node(NodeList *head, DeviceList *devicelist, char *nodename);
	NodeList *query_in_nodelist(char *name);
	void gen_nodelist();
	void gen_np_char_netlist();
	InoutList *insert_output(InoutList *head, InoutList *curr);
	void generate_output_pinlist();
	void generate_input_pinlist();
	char *get_vdd(MosList *moshead);
	char *get_gnd(MosList *moshead);
	void delete_vdd_gnd_from_inputlist();
};


#endif
